wm attributes . -fullscreen 1

label .hello -text "Hello World!" -font {{DejaVu Sans} 22}

set colorList {red blue yellow magenta cyan orange green}

proc rcolor {colorList} {
    return [lindex $colorList \
       [expr {int(rand() * [llength $colorList])}]]
}

set c_width [expr {[winfo screenwidth .] / 2}]
set c_height [expr {[winfo screenheight . ] / 2}]
if {$c_width > $c_height} {
    set c_width $c_height
} else {
    set c_height $c_width
}
set radius [expr {round($c_width / 33.0)}]

canvas .canvas -bg black -width $c_width -height $c_height

proc make_items {} {
    global c_width c_height radius DX DY itemList colorList
    catch {unset itemList}
    for {set count 0} {$count < 10} {incr count} {
        set item [.canvas create oval \
            [expr {$c_width / 2 - $radius}] \
            [expr {$c_height / 2 - $radius}] \
            [expr {$c_width / 2 + $radius}] \
            [expr {$c_height / 2 + $radius}] \
            -fill [rcolor $colorList] \
            -width 0]
        set DX($item) [expr {(rand() -0.5) * 10}]
        set DY($item) [expr {(rand() -0.5) * 10}]
        lappend itemList $item
    }
}

proc move_items {} {
    global c itemList DX DY c_width c_height
    set collision 0
    .hello configure -foreground black
    foreach item $itemList {
        .canvas move $item $DX($item) $DY($item)
        foreach i {xmin ymin xmax ymax} j [.canvas coords $item] {
            set $i $j
        }
        if {$xmax > $c_width || $xmin < 0} {
            set DX($item) [expr {-$DX($item)}]
            incr collision
        }
        if {$ymax > $c_height || $ymin < 0} {
            set DY($item) [expr {-$DY($item)}]
            incr collision
        }
    }
    after 40 move_items
    if {$collision} {
	.hello configure -foreground #707070
        catch {borg vibrate 80}
    }
}

make_items

ttk::button .console -text "Console ..." -width 14 \
    -command {console hide ; console show}
ttk::button .exit -text "Exit" -width 14 \
    -command exit
pack .hello .canvas .console .exit -side top -expand 1

bind . <<WillEnterBackground>> {
    after cancel move_items
    console hide
}

bind . <<WillEnterForeground>> {
    after cancel move_items
    after idle move_items
    focus .
}

bind . <Key-Break> {borg withdraw}

move_items

